<%
'(C) Copyright 2001 by UltraApps
'View files/license.html for Legal Information
'-------------------------------
' IssueChange CustomIncludes begin
%>

<!-- #INCLUDE FILE="Common.asp" -->
<!-- #INCLUDE FILE="Header.asp" -->
<!-- #INCLUDE FILE="Footer.asp" -->

<%
' IssueChange CustomIncludes end
'-------------------------------

'===============================
' Save Page and File Name available into variables
'-------------------------------
sFileName = "IssueChange.asp"
sTemplateFileName = "IssueChange.html"
'===============================


'===============================
' IssueChange PageSecurity begin
CheckSecurity(1)
' IssueChange PageSecurity end
'===============================

'===============================
' IssueChange Open Event begin
' IssueChange Open Event end
'===============================

'===============================
' IssueChange OpenAnyPage Event begin
' IssueChange OpenAnyPage Event end
'===============================

'===============================
'Save the name of the form and type of action into the variables
'-------------------------------
sAction = GetParam("FormAction")
sForm = GetParam("FormName")
'===============================

' IssueChange Show begin
'===============================
' Perform the form's action
'-------------------------------
' Initialize error variables
'-------------------------------
sIssueErr = ""
sResponseErr = ""

'-------------------------------
' Select the FormAction
'-------------------------------
Select Case sForm
  Case "Issue"
    IssueAction(sAction)
  Case "Response"
    ResponseAction(sAction)
end select
'===============================

'===============================
' Display page
'-------------------------------
' Load HTML template for this page
'-------------------------------
LoadTemplate sAppPath & sTemplateFileName, "main"
'-------------------------------
' Load HTML template of Header and Footer
'-------------------------------
LoadTemplate sHeaderFileName, "Header"
LoadTemplate sFooterFileName, "Footer"
'-------------------------------
SetVar "FileName", sFileName


'-------------------------------
' Step through each form
'-------------------------------
Menu_Show
FooterForm_Show
Issue_Show
Response_Show
History_Show
'-------------------------------
' Process page templates
'-------------------------------
Parse "Header", False
Parse "Footer", False
Parse "main", False
'-------------------------------
' Output the page to the browser
'-------------------------------
Response.write PrintVar("main")

' IssueChange Show end

'-------------------------------
' Destroy all object variables
'-------------------------------
cn.Close
Set cn = Nothing
UnloadTemplate
'===============================

'===============================
' IssueChange Close Event begin
' IssueChange Close Event end
'===============================
'===============================
' Action of the Record Form
'-------------------------------
Sub IssueAction(sAction)
'-------------------------------
' Initialize variables  
'-------------------------------
  Dim bExecSQL: bExecSQL = true
  Dim sActionFileName : sActionFileName = ""
  Dim sWhere : sWhere = "" 
  Dim bErr : bErr = False
  Dim pPKissue_id : pPKissue_id = ""
'-------------------------------

'-------------------------------
' Issue Action begin
'-------------------------------
  sActionFileName = "Default.asp"

'-------------------------------
' Load all form fields into variables
'-------------------------------
  fldUserID = Session("UserID")

'-------------------------------
' Validate fields
'-------------------------------
  if sAction = "insert" or sAction = "update" then
'-------------------------------
' Issue Check Event begin
' Issue Check Event end
'-------------------------------
    If len(sIssueErr) > 0 then
      exit sub
    end if
  end if
'-------------------------------

'-------------------------------
' Issue BeforeExecute Event begin
' Issue BeforeExecute Event end
'-------------------------------

'-------------------------------
' Execute SQL statement
'-------------------------------
if len(sIssueErr) > 0 then Exit Sub
  on error resume next
  if bExecSQL then 
    cn.execute sSQL
  end if
  sIssueErr = ProcessError
  on error goto 0
  if len(sIssueErr) > 0 then Exit Sub
  cn.Close
  Set cn = Nothing
  response.redirect sActionFileName
'-------------------------------
' Issue Action end
'-------------------------------
end sub
'===============================

'===============================
' Display Record Form
'-------------------------------
Sub Issue_Show()
'-------------------------------
' Issue Show begin
'-------------------------------
  Dim sWhere : sWhere = ""
  Dim sFormTitle: sFormTitle = "Issue"
  Dim bPK : bPK = True

'-------------------------------
' Load primary key and form parameters
'-------------------------------
  if sIssueErr = "" then
    fldIssue_id = GetParam("Issue_id")
    pissue_id = GetParam("Issue_id")
    SetVar "IssueError", ""
  else
    fldissue_id = GetParam("issue_id")
    pissue_id = GetParam("PK_Issue_id")
    SetVar "sIssueErr", sIssueErr
    SetVar "FormTitle", sFormTitle
    Parse "IssueError", False
  end if
'-------------------------------

'-------------------------------
' Load all form fields

'-------------------------------

'-------------------------------
' Build WHERE statement

  if IsEmpty(pissue_id) then bPK = False
  
  sWhere = sWhere & "issue_id=" & ToSQL(pissue_id, "Number")
  SetVar "PK_issue_id", pissue_id
'-------------------------------
'-------------------------------
' Issue Open Event begin
' Issue Open Event end
'-------------------------------

  SetVar "FormTitle", sFormTitle

'-------------------------------
' Build SQL statement and open recordset
'-------------------------------
  sSQL = "select * from issues where " & sWhere
  openStaticRS rs, sSQL
  bIsUpdateMode = (bPK and not(sAction = "insert" and sForm = "Issue") and not rs.eof)
'-------------------------------

'-------------------------------
' Load lists of values
'-------------------------------

  atested = Split("1;Yes", ";")
  aapproved = Split("1;Yes", ";")
'-------------------------------

'-------------------------------
' Load all fields into variables from recordset or input parameters
'-------------------------------
  if bIsUpdateMode then
    fldapproved = GetValue(rs, "approved")
    fldassigned_to = GetValue(rs, "assigned_to")
    fldassigned_to_orig = GetValue(rs, "assigned_to_orig")
    flddate_submitted = GetValue(rs, "date_submitted")
    fldissue_desc = GetValue(rs, "issue_desc")
    fldissue_id = GetValue(rs, "issue_id")
    fldissue_name = GetValue(rs, "issue_name")
    fldpriority_id = GetValue(rs, "priority_id")
    fldstatus_id = GetValue(rs, "status_id")
    fldtested = GetValue(rs, "tested")
    flduser_id = GetValue(rs, "user_id")
    fldversion = GetValue(rs, "version")
    SetVar "IssueDelete", ""
    SetVar "IssueUpdate", ""
    SetVar "IssueInsert", ""
'-------------------------------
' Issue ShowEdit Event begin
' Issue ShowEdit Event end
'-------------------------------
  else
    if sIssueErr = "" then
      fldissue_id = ToHTML(GetParam("Issue_id"))
    end if
    SetVar "IssueEdit", ""
    SetVar "IssueInsert", ""
'-------------------------------
' Issue ShowInsert Event begin
' Issue ShowInsert Event end
'-------------------------------
  end if
  SetVar "IssueCancel", ""

'-------------------------------
' Set lookup fields
'-------------------------------
  flduser_id = DLookUp("users", "user_name", "user_id=" & ToSQL(flduser_id, "Number"))
  fldassigned_to_orig = DLookUp("users", "user_name", "user_id=" & ToSQL(fldassigned_to_orig, "Number"))
  fldassigned_to = DLookUp("users", "user_name", "user_id=" & ToSQL(fldassigned_to, "Number"))
  fldpriority_id = DLookUp("priorities", "priority_desc", "priority_id=" & ToSQL(fldpriority_id, "Number"))
  fldstatus_id = DLookUp("statuses", "status", "status_id=" & ToSQL(fldstatus_id, "Number"))
  if sIssueErr = "" then
'-------------------------------
' Issue Show Event begin
fldissue_desc = Replace(fldissue_desc,VBcrlf,"<br>")
' Issue Show Event end
'-------------------------------
  end if

'-------------------------------
' Show form field
'-------------------------------
      SetVar "issue_id", ToHTML(fldissue_id)
      SetVar "issue_name", ToHTML(fldissue_name)
      SetVar "issue_desc", fldissue_desc
      SetVar "user_id", ToHTML(flduser_id)
      SetVar "date_submitted", ToHTML(flddate_submitted)
      SetVar "version", ToHTML(fldversion)
      fldtested = getValFromLOV(fldtested, atested)
      SetVar "tested", ToHTML(fldtested)
      fldapproved = getValFromLOV(fldapproved, aapproved)
      SetVar "approved", ToHTML(fldapproved)
      SetVar "assigned_to_orig", ToHTML(fldassigned_to_orig)
      SetVar "assigned_to", ToHTML(fldassigned_to)
      SetVar "priority_id", ToHTML(fldpriority_id)
      SetVar "status_id", ToHTML(fldstatus_id)
  Parse "FormIssue", False

'-------------------------------
' Issue Close Event begin
' Issue Close Event end
'-------------------------------

Set rs = Nothing

'-------------------------------
' Issue Show end
'-------------------------------
End Sub
'===============================
'===============================
' Action of the Record Form
'-------------------------------
Sub ResponseAction(sAction)
'-------------------------------
' Initialize variables  
'-------------------------------
  Dim bExecSQL: bExecSQL = true
  Dim sActionFileName : sActionFileName = ""
  Dim sParams : sParams = "?"
  Dim sWhere : sWhere = "" 
  Dim bErr : bErr = False
  Dim pPKresponse_id : pPKresponse_id = ""
  Dim fldissue_id : fldissue_id = ""
  Dim flduser_id : flduser_id = ""
  Dim flddate_response : flddate_response = ""
  Dim fldresponse : fldresponse = ""
  Dim fldassigned_to : fldassigned_to = ""
  Dim fldpriority_id : fldpriority_id = ""
  Dim fldstatus_id : fldstatus_id = ""
  Dim fldversion : fldversion = ""
  Dim fldtested : fldtested = ""
  Dim fldapproved : fldapproved = ""
  Dim flddate_modified : flddate_modified = ""
  Dim fldmodified_by : fldmodified_by = ""
  Dim flddate_resolved : flddate_resolved = ""
'-------------------------------

'-------------------------------
' Response Action begin
'-------------------------------
  sActionFileName = "Default.asp"
  sParams = sParams & "issue_id=" & ToURL(GetParam("Trn_issue_id")) & "&"
  sParams = sParams & "assigned_to=" & ToURL(GetParam("Trn_assigned_to")) & "&"
  sParams = sParams & "priority_id=" & ToURL(GetParam("Trn_priority_id")) & "&"
  sParams = sParams & "status_id=" & ToURL(GetParam("Trn_status_id"))

'-------------------------------
' Load all form fields into variables
'-------------------------------
  fldissue_id = GetParam("issue_id")
  flduser_id = GetParam("user_id")
  flddate_response = GetParam("date_response")
  fldresponse = GetParam("response")
  fldassigned_to = GetParam("assigned_to")
  fldpriority_id = GetParam("priority_id")
  fldstatus_id = GetParam("status_id")
  fldversion = GetParam("version")
  fldtested = getCheckBoxValue(GetParam("tested"), "1", "0", "Number")
  fldapproved = getCheckBoxValue(GetParam("approved"), "1", "0", "Number")
  flddate_modified = GetParam("date_modified")
  fldmodified_by = GetParam("modified_by")
  flddate_resolved = GetParam("date_resolved")

'-------------------------------
' Validate fields
'-------------------------------
  if sAction = "insert" or sAction = "update" then
    if IsEmpty(fldpriority_id) then
      sResponseErr = sResponseErr & "The value in field Priority is required.<br>"
    end if
    if IsEmpty(fldstatus_id) then
      sResponseErr = sResponseErr & "The value in field New Status is required.<br>"
    end if
    if not isNumeric(fldissue_id) then
      sResponseErr = sResponseErr & "The value in field issue_id is incorrect.<br>"
    end if
    if not isNumeric(flduser_id) then
      sResponseErr = sResponseErr & "The value in field user_id is incorrect.<br>"
    end if
    if not isNumeric(fldassigned_to) then
      sResponseErr = sResponseErr & "The value in field ReAssign To is incorrect.<br>"
    end if
    if not isNumeric(fldpriority_id) then
      sResponseErr = sResponseErr & "The value in field Priority is incorrect.<br>"
    end if
    if not isNumeric(fldstatus_id) then
      sResponseErr = sResponseErr & "The value in field New Status is incorrect.<br>"
    end if
    if not isNumeric(fldmodified_by) then
      sResponseErr = sResponseErr & "The value in field modified_by is incorrect.<br>"
    end if
'-------------------------------
' Response Check Event begin
' Response Check Event end
'-------------------------------
    If len(sResponseErr) > 0 then
      exit sub
    end if
  end if
'-------------------------------


'-------------------------------
' Create SQL statement
'-------------------------------
  select case sAction
    case "insert"
'-------------------------------
' Response Insert Event begin
flddate_response = Now()

'Build issue update SQL
issues_sql = "UPDATE issues SET assigned_to=" & fldassigned_to & ", priority_id=" & fldpriority_id & ", status_id=" & fldstatus_id & ", [version]='" & fldversion & "', tested=" & fldtested & ", approved=" & fldapproved & ", modified_by=" & Session("UserID") & ", date_modified='" & Now() & "'"
'If Closed
if DLookup("statuses","status","status_id=" & fldstatus_id) = "Closed" then issues_sql = issues_sql & ", date_resolved='" & Now() & "'"
'Complete SQL with WHERE
issues_sql = issues_sql & " WHERE issue_id=" & fldissue_id
'Execute SQL
'response.write(issues_sql)
cn.execute issues_sql
' Response Insert Event end
'-------------------------------
      if sSQL = "" then
      sSQL = "insert into responses (" & _
          "[issue_id]," & _
          "[user_id]," & _
          "[date_response]," & _
          "[response]," & _
          "[assigned_to]," & _
          "[priority_id]," & _
          "[status_id]," & _
          "[version]," & _
          "[tested]," & _
          "[approved])" & _
          " values (" & _
          ToSQL(fldissue_id, "Number") & "," & _
          ToSQL(flduser_id, "Number") & "," & _
          ToSQL(flddate_response, "Date") & "," & _
          ToSQL(fldresponse, "Text") & "," & _
          ToSQL(fldassigned_to, "Number") & "," & _
          ToSQL(fldpriority_id, "Number") & "," & _
          ToSQL(fldstatus_id, "Number") & "," & _
          ToSQL(fldversion, "Text") & "," & _
          fldtested & "," & _
          fldapproved & _
          ")"
      end if
  end select
'-------------------------------
'-------------------------------
' Response BeforeExecute Event begin
' Response BeforeExecute Event end
'-------------------------------

'-------------------------------
' Execute SQL statement
'-------------------------------
if len(sResponseErr) > 0 then Exit Sub
  on error resume next
  if bExecSQL then 
    cn.execute sSQL
  end if
  sResponseErr = ProcessError
  on error goto 0
  if len(sResponseErr) > 0 then Exit Sub
  cn.Close
  Set cn = Nothing
  response.redirect sActionFileName & sParams
'-------------------------------
' Response Action end
'-------------------------------
end sub
'===============================

'===============================
' Display Record Form
'-------------------------------
Sub Response_Show()
'-------------------------------
' Response Show begin
'-------------------------------
  Dim sWhere : sWhere = ""
  Dim sFormTitle: sFormTitle = "Response"
  Dim bPK : bPK = True

'-------------------------------
' Load primary key and form parameters
'-------------------------------
  if sResponseErr = "" then
    fldissue_id = GetParam("issue_id")
    fldassigned_to = GetParam("assigned_to")
    fldpriority_id = GetParam("priority_id")
    fldstatus_id = GetParam("status_id")
    SetVar "Trn_issue_id", GetParam("issue_id")
    SetVar "Trn_assigned_to", GetParam("assigned_to")
    SetVar "Trn_priority_id", GetParam("priority_id")
    SetVar "Trn_status_id", GetParam("status_id")
    presponse_id = GetParam("response_id")
    SetVar "ResponseError", ""
  else
    fldresponse_id = GetParam("response_id")
    fldissue_id = GetParam("issue_id")
    flduser_id = GetParam("user_id")
    flddate_response = GetParam("date_response")
    fldresponse = GetParam("response")
    fldassigned_to = GetParam("assigned_to")
    fldpriority_id = GetParam("priority_id")
    fldstatus_id = GetParam("status_id")
    fldversion = GetParam("version")
    fldtested = getCheckBoxValue(GetParam("tested"), "1", "0", "Number")
    fldapproved = getCheckBoxValue(GetParam("approved"), "1", "0", "Number")
    SetVar "Trn_issue_id", GetParam("Trn_issue_id")
    SetVar "Trn_assigned_to", GetParam("Trn_assigned_to")
    SetVar "Trn_priority_id", GetParam("Trn_priority_id")
    SetVar "Trn_status_id", GetParam("Trn_status_id")
    presponse_id = GetParam("PK_response_id")
    SetVar "sResponseErr", sResponseErr
    SetVar "FormTitle", sFormTitle
    Parse "ResponseError", False
  end if
'-------------------------------

'-------------------------------
' Load all form fields

  flddate_modified = GetParam("date_modified")
  fldmodified_by = GetParam("modified_by")
  flddate_resolved = GetParam("date_resolved")
'-------------------------------

'-------------------------------
' Build WHERE statement

  if IsEmpty(presponse_id) then bPK = False
  
  sWhere = sWhere & "response_id=" & ToSQL(presponse_id, "Number")
  SetVar "PK_response_id", presponse_id
'-------------------------------
'-------------------------------
' Response Open Event begin
' Response Open Event end
'-------------------------------

  SetVar "FormTitle", sFormTitle

'-------------------------------
' Build SQL statement and open recordset
'-------------------------------
  sSQL = "select * from responses where " & sWhere
  openrs rs, sSQL
  bIsUpdateMode = (bPK and not(sAction = "insert" and sForm = "Response") and not rs.eof)
'-------------------------------

'-------------------------------
' Load all fields into variables from recordset or input parameters
'-------------------------------
  if bIsUpdateMode then
    flddate_response = GetValue(rs, "date_response")
    fldissue_id = GetValue(rs, "issue_id")
    fldresponse_id = GetValue(rs, "response_id")
    flduser_id = GetValue(rs, "user_id")

'-------------------------------
' Load data from recordset when form displayed first time
'-------------------------------
    if sResponseErr = "" then
      fldresponse = GetValue(rs, "response")
      fldassigned_to = GetValue(rs, "assigned_to")
      fldpriority_id = GetValue(rs, "priority_id")
      fldstatus_id = GetValue(rs, "status_id")
      fldversion = GetValue(rs, "version")
      fldtested = GetValue(rs, "tested")
      fldapproved = GetValue(rs, "approved")
    end if
    SetVar "ResponseDelete", ""
    SetVar "ResponseUpdate", ""
    SetVar "ResponseInsert", ""
'-------------------------------
' Response ShowEdit Event begin
' Response ShowEdit Event end
'-------------------------------
  else
    if sResponseErr = "" then
      fldissue_id = ToHTML(GetParam("issue_id"))
      flduser_id = ToHTML(Session("UserID"))
      fldassigned_to = ToHTML(GetParam("assigned_to"))
      fldpriority_id = ToHTML(GetParam("priority_id"))
      fldstatus_id = ToHTML(GetParam("status_id"))
    end if
    SetVar "ResponseEdit", ""
    Parse "ResponseInsert", False
'-------------------------------
' Response ShowInsert Event begin
' Response ShowInsert Event end
'-------------------------------
  end if
  SetVar "ResponseCancel", ""
  if sResponseErr = "" then
'-------------------------------
' Response Show Event begin
issues_sql = "SELECT assigned_to, priority_id, status_id, version, tested, approved, date_resolved FROM issues where issue_id=" & GetParam("issue_id")
openrs issues_rs, issues_sql
fldassigned_to = GetValue(issues_rs,"assigned_to")
fldpriority_id = GetValue(issues_rs,"priority_id")
fldstatus_id = GetValue(issues_rs,"status_id")
fldversion = GetValue(issues_rs,"version")
fldtested = GetValue(issues_rs,"tested")
fldapproved = GetValue(issues_rs,"approved")
flddate_resolved = GetValue(issues_rs,"date_resolved")
' Response Show Event end
'-------------------------------
  end if

'-------------------------------
' Show form field
'-------------------------------
      SetVar "response_id", ToHTML(fldresponse_id)
      SetVar "issue_id", ToHTML(fldissue_id)
      SetVar "user_id", ToHTML(flduser_id)
      SetVar "date_response", ToHTML(flddate_response)
      SetVar "response", ToHTML(fldresponse)
      SetVar "ResponseLBassigned_to", ""
      openrs rsassigned_to, "select user_id, user_name from users order by 2"
      while not rsassigned_to.EOF
        SetVar "ID", GetValue(rsassigned_to, 0) : SetVar "Value", GetValue(rsassigned_to, 1)
        if cstr(GetValue(rsassigned_to, 0)) = cstr(fldassigned_to) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "ResponseLBassigned_to", True
        rsassigned_to.MoveNext
      wend
      set rsassigned_to = nothing
    
      SetVar "ResponseLBpriority_id", ""
      openrs rspriority_id, "select priority_id, priority_desc from priorities order by 2"
      while not rspriority_id.EOF
        SetVar "ID", GetValue(rspriority_id, 0) : SetVar "Value", GetValue(rspriority_id, 1)
        if cstr(GetValue(rspriority_id, 0)) = cstr(fldpriority_id) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "ResponseLBpriority_id", True
        rspriority_id.MoveNext
      wend
      set rspriority_id = nothing
    
      SetVar "ResponseLBstatus_id", ""
      openrs rsstatus_id, "select status_id, status from statuses order by 2"
      while not rsstatus_id.EOF
        SetVar "ID", GetValue(rsstatus_id, 0) : SetVar "Value", GetValue(rsstatus_id, 1)
        if cstr(GetValue(rsstatus_id, 0)) = cstr(fldstatus_id) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "ResponseLBstatus_id", True
        rsstatus_id.MoveNext
      wend
      set rsstatus_id = nothing

      SetVar "version", ToHTML(fldversion)
  if (LCase(fldtested) = LCase("1")) then
    SetVar "tested_CHECKED", "CHECKED"
  else
    SetVar "tested_CHECKED", ""
  end if

  if (LCase(fldapproved) = LCase("1")) then
    SetVar "approved_CHECKED", "CHECKED"
  else
    SetVar "approved_CHECKED", ""
  end if

      SetVar "date_modified", ToHTML(flddate_modified)
      SetVar "modified_by", ToHTML(fldmodified_by)
      SetVar "date_resolved", ToHTML(flddate_resolved)
  Parse "FormResponse", False

'-------------------------------
' Response Close Event begin
' Response Close Event end
'-------------------------------

Set rs = Nothing

'-------------------------------
' Response Show end
'-------------------------------
End Sub
'===============================

'===============================
' Display Grid Form
'-------------------------------
Sub History_Show()
'-------------------------------
' Initialize variables  
'-------------------------------
  Dim rs
  Dim sWhere : sWhere = ""
  Dim sOrder : sOrder = ""
  Dim sSQL : sSQL = ""
  Dim sFormTitle: sFormTitle = "Response History"
  Dim HasParam : HasParam = false
  Dim bReq : bReq = true

  SetVar "TransitParams", ""
  SetVar "FormParams", "issue_id=" & ToURL(GetParam("issue_id")) & "&"

'-------------------------------
' Build WHERE statement
'-------------------------------
  pissue_id = GetParam("issue_id")
  if IsNumeric(pissue_id) and not isEmpty(pissue_id) then pissue_id = ToSQL(pissue_id, "Number") else pissue_id = Empty
  if not isEmpty(pissue_id) then
    HasParam = true
    sWhere = sWhere & "r.[issue_id]=" & pissue_id
  else
    bReq = false
  end if


  if HasParam then
    sWhere = " AND (" & sWhere & ")"
  end if
  
'-------------------------------
' Build ORDER BY statement
'-------------------------------
  sOrder = " order by r.date_response Desc"

'-------------------------------
' Build base SQL statement
'-------------------------------
  sSQL = "select [r].[assigned_to] as r_assigned_to, " & _
    "[r].[date_response] as r_date_response, " & _
    "[r].[issue_id] as r_issue_id, " & _
    "[r].[priority_id] as r_priority_id, " & _
    "[r].[response] as r_response, " & _
    "[r].[response_id] as r_response_id, " & _
    "[r].[status_id] as r_status_id, " & _
    "[r].[user_id] as r_user_id, " & _
    "[u].[user_id] as u_user_id, " & _
    "[u].[user_name] as u_user_name, " & _
    "[u1].[user_id] as u1_user_id, " & _
    "[u1].[user_name] as u1_user_name, " & _
    "[p].[priority_id] as p_priority_id, " & _
    "[p].[priority_desc] as p_priority_desc, " & _
    "[s].[status_id] as s_status_id, " & _
    "[s].[status] as s_status " & _
    " from [responses] r, [users] u, [users] u1, [priorities] p, [statuses] s" & _
    " where [u].[user_id]=r.[user_id] and [u1].[user_id]=r.[assigned_to] and [p].[priority_id]=r.[priority_id] and [s].[status_id]=r.[status_id]  "
'-------------------------------

'-------------------------------
' History Open Event begin
'Don't Display if no records
openrs rs, sSQL & sWhere & sOrder
if rs.eof then
    set rs = nothing
    SetVar "FormHistory","" 
    exit sub
end if
' History Open Event end
'-------------------------------

'-------------------------------
' Assemble full SQL statement
'-------------------------------
  sSQL = sSQL & sWhere & sOrder
'-------------------------------

SetVar "FormTitle", sFormTitle

'-------------------------------
' Process if form has all required parameter
'-------------------------------
  if not bReq then
    SetVar "DListHistory", ""
    Parse "HistoryNoRecords", False
    Parse "FormHistory", False
    exit sub
  end if
'-------------------------------

'-------------------------------
' Open the recordset
'-------------------------------
  openrs rs, sSQL
'-------------------------------

'-------------------------------
' Process empty recordset
'-------------------------------
  if rs.eof then
    set rs = nothing
    SetVar "DListHistory", ""
    Parse "HistoryNoRecords", False
    Parse "FormHistory", False
    exit sub
  end if
'-------------------------------


'-------------------------------
' Display grid based on recordset
'-------------------------------
  while not rs.EOF 
'-------------------------------
' Create field variables based on database fields
'-------------------------------
    fldassigned_to = GetValue(rs, "u1_user_name")
    flddate_response = GetValue(rs, "r_date_response")
    fldissue_id = GetValue(rs, "r_issue_id")
    fldpriority_id = GetValue(rs, "p_priority_desc")
    fldresponse = GetValue(rs, "r_response")
    fldresponse_id = GetValue(rs, "r_response_id")
    fldstatus_id = GetValue(rs, "s_status")
    flduser_id = GetValue(rs, "u_user_name")
'-------------------------------
' History Show begin
'-------------------------------

'-------------------------------
' History Show Event begin
fldresponse = replace(fldresponse,VBcrlf,"<br>")
' History Show Event end
'-------------------------------

'-------------------------------
' Replace Template fields with database values
'-------------------------------
    
      SetVar "response_id", ToHTML(fldresponse_id)
      SetVar "issue_id", ToHTML(fldissue_id)
      SetVar "user_id", ToHTML(flduser_id)
      SetVar "date_response", ToHTML(flddate_response)
      SetVar "response", fldresponse
      SetVar "assigned_to", ToHTML(fldassigned_to)
      SetVar "priority_id", ToHTML(fldpriority_id)
      SetVar "status_id", ToHTML(fldstatus_id)
'-------------------------------
' Process the record separator
'-------------------------------
    if rs.EOF  then
       SetVar "HistoryRecordSeparator", ""
    else
      Parse "HistoryRecordSeparator", false
    end if
'-------------------------------
    Parse "DListHistory", True

'-------------------------------
' History Show end
'-------------------------------

'-------------------------------
' Move to the next record 
'-------------------------------
    rs.MoveNext
  wend
'-------------------------------


'-------------------------------
' Finish form processing
'-------------------------------
  set rs = nothing
  SetVar "HistoryNoRecords", ""
  Parse "FormHistory", False

'-------------------------------
' History Close Event begin
' History Close Event end
'-------------------------------
End Sub
'===============================

%>