<%
'(C) Copyright 2001 by UltraApps
'View files/license.html for Legal Information
'-------------------------------
' IssueNew CustomIncludes begin
%>

<!-- #INCLUDE FILE="Common.asp" -->
<!-- #INCLUDE FILE="Header.asp" -->
<!-- #INCLUDE FILE="Footer.asp" -->

<%
' IssueNew CustomIncludes end
'-------------------------------

'===============================
' Save Page and File Name available into variables
'-------------------------------
sFileName = "IssueNew.asp"
sTemplateFileName = "IssueNew.html"
'===============================


'===============================
' IssueNew PageSecurity begin
CheckSecurity(1)
' IssueNew PageSecurity end
'===============================

'===============================
' IssueNew Open Event begin
' IssueNew Open Event end
'===============================

'===============================
' IssueNew OpenAnyPage Event begin
' IssueNew OpenAnyPage Event end
'===============================

'===============================
'Save the name of the form and type of action into the variables
'-------------------------------
sAction = GetParam("FormAction")
sForm = GetParam("FormName")
'===============================

' IssueNew Show begin
'===============================
' Perform the form's action
'-------------------------------
' Initialize error variables
'-------------------------------
sIssuesErr = ""

'-------------------------------
' Select the FormAction
'-------------------------------
Select Case sForm
  Case "Issues"
    IssuesAction(sAction)
end select
'===============================

'===============================
' Display page
'-------------------------------
' Load HTML template for this page
'-------------------------------
LoadTemplate sAppPath & sTemplateFileName, "main"
'-------------------------------
' Load HTML template of Header and Footer
'-------------------------------
LoadTemplate sHeaderFileName, "Header"
LoadTemplate sFooterFileName, "Footer"
'-------------------------------
SetVar "FileName", sFileName


'-------------------------------
' Step through each form
'-------------------------------
Menu_Show
FooterForm_Show
Issues_Show
'-------------------------------
' Process page templates
'-------------------------------
Parse "Header", False
Parse "Footer", False
Parse "main", False
'-------------------------------
' Output the page to the browser
'-------------------------------
Response.write PrintVar("main")

' IssueNew Show end

'-------------------------------
' Destroy all object variables
'-------------------------------
cn.Close
Set cn = Nothing
UnloadTemplate
'===============================

'===============================
' IssueNew Close Event begin
' IssueNew Close Event end
'===============================
'===============================
' Action of the Record Form
'-------------------------------
Sub IssuesAction(sAction)
'-------------------------------
' Initialize variables  
'-------------------------------
  Dim bExecSQL: bExecSQL = true
  Dim sActionFileName : sActionFileName = ""
  Dim sWhere : sWhere = "" 
  Dim bErr : bErr = False
  Dim pPKissue_id : pPKissue_id = ""
  Dim fldissue_name : fldissue_name = ""
  Dim fldissue_desc : fldissue_desc = ""
  Dim fldpriority_id : fldpriority_id = ""
  Dim fldstatus_id : fldstatus_id = ""
  Dim fldversion : fldversion = ""
  Dim fldassigned_to : fldassigned_to = ""
  Dim flddate_submitted : flddate_submitted = ""
  Dim fldsubmitted_by : fldsubmitted_by = ""
  Dim flddate_modified : flddate_modified = ""
  Dim fldassigned_to_orig : fldassigned_to_orig = ""
'-------------------------------

'-------------------------------
' Issues Action begin
'-------------------------------
  sActionFileName = "Default.asp"

'-------------------------------
' Load all form fields into variables
'-------------------------------
  fldissue_name = GetParam("issue_name")
  fldissue_desc = GetParam("issue_desc")
  fldpriority_id = GetParam("priority_id")
  fldstatus_id = GetParam("status_id")
  fldversion = GetParam("version")
  fldassigned_to = GetParam("assigned_to")
  flddate_submitted = GetParam("date_submitted")
  fldsubmitted_by = GetParam("submitted_by")
  flddate_modified = GetParam("date_modified")
  fldassigned_to_orig = GetParam("assigned_to_orig")

'-------------------------------
' Validate fields
'-------------------------------
  if sAction = "insert" or sAction = "update" then
    if IsEmpty(fldissue_name) then
      sIssuesErr = sIssuesErr & "The value in field Issue Name is required.<br>"
    end if
    if IsEmpty(fldpriority_id) then
      sIssuesErr = sIssuesErr & "The value in field Priority is required.<br>"
    end if
    if IsEmpty(fldstatus_id) then
      sIssuesErr = sIssuesErr & "The value in field Status is required.<br>"
    end if
    if not isNumeric(fldpriority_id) then
      sIssuesErr = sIssuesErr & "The value in field Priority is incorrect.<br>"
    end if
    if not isNumeric(fldstatus_id) then
      sIssuesErr = sIssuesErr & "The value in field Status is incorrect.<br>"
    end if
    if not isNumeric(fldassigned_to) then
      sIssuesErr = sIssuesErr & "The value in field Assigned To is incorrect.<br>"
    end if
    if not isNumeric(fldsubmitted_by) then
      sIssuesErr = sIssuesErr & "The value in field submitted_by is incorrect.<br>"
    end if
    if not isNumeric(fldassigned_to_orig) then
      sIssuesErr = sIssuesErr & "The value in field assigned_to_orig is incorrect.<br>"
    end if
'-------------------------------
' Issues Check Event begin
' Issues Check Event end
'-------------------------------
    If len(sIssuesErr) > 0 then
      exit sub
    end if
  end if
'-------------------------------


'-------------------------------
' Create SQL statement
'-------------------------------
  select case sAction
    case "insert"
'-------------------------------
' Issues Insert Event begin
flddate_modified = Now()
flddate_submitted = Now()

fldassigned_to_orig = fldassigned_to
flduser_id_orig = fldsubmitted_by
' Issues Insert Event end
'-------------------------------
      if sSQL = "" then
      sSQL = "insert into issues (" & _
          "[issue_name]," & _
          "[issue_desc]," & _
          "[priority_id]," & _
          "[status_id]," & _
          "[version]," & _
          "[assigned_to]," & _
          "[date_submitted]," & _
          "[user_id]," & _
          "[date_modified]," & _
          "[assigned_to_orig])" & _
          " values (" & _
          ToSQL(fldissue_name, "Text") & "," & _
          ToSQL(fldissue_desc, "Text") & "," & _
          ToSQL(fldpriority_id, "Number") & "," & _
          ToSQL(fldstatus_id, "Number") & "," & _
          ToSQL(fldversion, "Text") & "," & _
          ToSQL(fldassigned_to, "Number") & "," & _
          ToSQL(flddate_submitted, "Date") & "," & _
          ToSQL(fldsubmitted_by, "Number") & "," & _
          ToSQL(flddate_modified, "Date") & "," & _
          ToSQL(fldassigned_to_orig, "Number") & _
          ")"
      end if
  end select
'-------------------------------
'-------------------------------
' Issues BeforeExecute Event begin
' Issues BeforeExecute Event end
'-------------------------------

'-------------------------------
' Execute SQL statement
'-------------------------------
if len(sIssuesErr) > 0 then Exit Sub
  on error resume next
  if bExecSQL then 
    cn.execute sSQL
  end if
  sIssuesErr = ProcessError
  on error goto 0
  if len(sIssuesErr) > 0 then Exit Sub
  cn.Close
  Set cn = Nothing
  response.redirect sActionFileName
'-------------------------------
' Issues Action end
'-------------------------------
end sub
'===============================

'===============================
' Display Record Form
'-------------------------------
Sub Issues_Show()
'-------------------------------
' Issues Show begin
'-------------------------------
  Dim sWhere : sWhere = ""
  Dim sFormTitle: sFormTitle = "Add/Edit Issue"
  Dim bPK : bPK = True

'-------------------------------
' Load primary key and form parameters
'-------------------------------
  if sIssuesErr = "" then
    fldissue_id = GetParam("issue_id")
    pissue_id = GetParam("issue_id")
    SetVar "IssuesError", ""
  else
    fldissue_id = GetParam("issue_id")
    fldissue_name = GetParam("issue_name")
    fldissue_desc = GetParam("issue_desc")
    fldpriority_id = GetParam("priority_id")
    fldstatus_id = GetParam("status_id")
    fldversion = GetParam("version")
    fldassigned_to = GetParam("assigned_to")
    flddate_submitted = GetParam("date_submitted")
    fldsubmitted_by = GetParam("submitted_by")
    flddate_modified = GetParam("date_modified")
    fldassigned_to_orig = GetParam("assigned_to_orig")
    pissue_id = GetParam("PK_issue_id")
    fldsubmitted_by_l = Session("UserID")
    SetVar "sIssuesErr", sIssuesErr
    SetVar "FormTitle", sFormTitle
    Parse "IssuesError", False
  end if
'-------------------------------

'-------------------------------
' Load all form fields

'-------------------------------

'-------------------------------
' Build WHERE statement

  if IsEmpty(pissue_id) then bPK = False
  
  sWhere = sWhere & "issue_id=" & ToSQL(pissue_id, "Number")
  SetVar "PK_issue_id", pissue_id
'-------------------------------
'-------------------------------
' Issues Open Event begin
' Issues Open Event end
'-------------------------------

  SetVar "FormTitle", sFormTitle

'-------------------------------
' Build SQL statement and open recordset
'-------------------------------
  sSQL = "select * from issues where " & sWhere
  openrs rs, sSQL
  bIsUpdateMode = (bPK and not(sAction = "insert" and sForm = "Issues") and not rs.eof)
'-------------------------------

'-------------------------------
' Load all fields into variables from recordset or input parameters
'-------------------------------
  if bIsUpdateMode then
    fldassigned_to_orig = GetValue(rs, "assigned_to_orig")
    flddate_modified = GetValue(rs, "date_modified")
    flddate_submitted_l = GetValue(rs, "date_submitted")
    flddate_submitted = GetValue(rs, "date_submitted")
    fldissue_id = GetValue(rs, "issue_id")
    fldsubmitted_by_l = GetValue(rs, "user_id")
    fldsubmitted_by = GetValue(rs, "user_id")

'-------------------------------
' Load data from recordset when form displayed first time
'-------------------------------
    if sIssuesErr = "" then
      fldissue_name = GetValue(rs, "issue_name")
      fldissue_desc = GetValue(rs, "issue_desc")
      fldpriority_id = GetValue(rs, "priority_id")
      fldstatus_id = GetValue(rs, "status_id")
      fldversion = GetValue(rs, "version")
      fldassigned_to = GetValue(rs, "assigned_to")
    end if
    SetVar "IssuesDelete", ""
    SetVar "IssuesUpdate", ""
    SetVar "IssuesInsert", ""
'-------------------------------
' Issues ShowEdit Event begin
' Issues ShowEdit Event end
'-------------------------------
  else
    if sIssuesErr = "" then
      fldissue_id = ToHTML(GetParam("issue_id"))
      fldsubmitted_by_l = ToHTML(Session("UserID"))
      fldsubmitted_by = ToHTML(Session("UserID"))
      fldpriority_id= "3"
      fldstatus_id= "1"
    end if
    SetVar "IssuesEdit", ""
    Parse "IssuesInsert", False
'-------------------------------
' Issues ShowInsert Event begin
' Issues ShowInsert Event end
'-------------------------------
  end if
  SetVar "IssuesCancel", ""

'-------------------------------
' Set lookup fields
'-------------------------------
  fldsubmitted_by_l = DLookUp("users", "user_name", "user_id=" & ToSQL(fldsubmitted_by_l, "Number"))
  if sIssuesErr = "" then
'-------------------------------
' Issues Show Event begin
flddate_submitted = Now()
flddate_submitted_l = flddate_submitted
fldsubmitted_by_l = DLookup("users","user_name","user_id=" & fldsubmitted_by)
' Issues Show Event end
'-------------------------------
  end if

'-------------------------------
' Show form field
'-------------------------------
      SetVar "issue_id", ToHTML(fldissue_id)
      SetVar "issue_name", ToHTML(fldissue_name)
      SetVar "issue_desc", ToHTML(fldissue_desc)
      SetVar "IssuesLBpriority_id", ""
      openrs rspriority_id, "select priority_id, priority_desc from priorities order by 2"
      while not rspriority_id.EOF
        SetVar "ID", GetValue(rspriority_id, 0) : SetVar "Value", GetValue(rspriority_id, 1)
        if cstr(GetValue(rspriority_id, 0)) = cstr(fldpriority_id) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "IssuesLBpriority_id", True
        rspriority_id.MoveNext
      wend
      set rspriority_id = nothing
    
      SetVar "IssuesLBstatus_id", ""
      openrs rsstatus_id, "select status_id, status from statuses order by 2"
      while not rsstatus_id.EOF
        SetVar "ID", GetValue(rsstatus_id, 0) : SetVar "Value", GetValue(rsstatus_id, 1)
        if cstr(GetValue(rsstatus_id, 0)) = cstr(fldstatus_id) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "IssuesLBstatus_id", True
        rsstatus_id.MoveNext
      wend
      set rsstatus_id = nothing
    
      SetVar "version", ToHTML(fldversion)
      SetVar "IssuesLBassigned_to", ""
      openrs rsassigned_to, "select user_id, user_name from users order by 2"
      while not rsassigned_to.EOF
        SetVar "ID", GetValue(rsassigned_to, 0) : SetVar "Value", GetValue(rsassigned_to, 1)
        if cstr(GetValue(rsassigned_to, 0)) = cstr(fldassigned_to) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "IssuesLBassigned_to", True
        rsassigned_to.MoveNext
      wend
      set rsassigned_to = nothing
    
      SetVar "submitted_by_l", ToHTML(fldsubmitted_by_l)
      SetVar "date_submitted_l", ToHTML(flddate_submitted_l)
      SetVar "date_submitted", ToHTML(flddate_submitted)
      SetVar "submitted_by", ToHTML(fldsubmitted_by)
      SetVar "date_modified", ToHTML(flddate_modified)
      SetVar "assigned_to_orig", ToHTML(fldassigned_to_orig)
  Parse "FormIssues", False

'-------------------------------
' Issues Close Event begin
' Issues Close Event end
'-------------------------------

Set rs = Nothing

'-------------------------------
' Issues Show end
'-------------------------------
End Sub
'===============================
%>