<%
'(C) Copyright 2001 by UltraApps
'View files/license.html for Legal Information
'-------------------------------
' ResponseMaint CustomIncludes begin
%>

<!-- #INCLUDE FILE="Common.asp" -->
<!-- #INCLUDE FILE="Header.asp" -->
<!-- #INCLUDE FILE="Footer.asp" -->

<%
' ResponseMaint CustomIncludes end
'-------------------------------

'===============================
' Save Page and File Name available into variables
'-------------------------------
sFileName = "ResponseMaint.asp"
sTemplateFileName = "ResponseMaint.html"
'===============================


'===============================
' ResponseMaint PageSecurity begin
CheckSecurity(3)
' ResponseMaint PageSecurity end
'===============================

'===============================
' ResponseMaint Open Event begin
' ResponseMaint Open Event end
'===============================

'===============================
' ResponseMaint OpenAnyPage Event begin
' ResponseMaint OpenAnyPage Event end
'===============================

'===============================
'Save the name of the form and type of action into the variables
'-------------------------------
sAction = GetParam("FormAction")
sForm = GetParam("FormName")
'===============================

' ResponseMaint Show begin
'===============================
' Perform the form's action
'-------------------------------
' Initialize error variables
'-------------------------------
sResponseErr = ""

'-------------------------------
' Select the FormAction
'-------------------------------
Select Case sForm
  Case "Response"
    ResponseAction(sAction)
end select
'===============================

'===============================
' Display page
'-------------------------------
' Load HTML template for this page
'-------------------------------
LoadTemplate sAppPath & sTemplateFileName, "main"
'-------------------------------
' Load HTML template of Header and Footer
'-------------------------------
LoadTemplate sHeaderFileName, "Header"
LoadTemplate sFooterFileName, "Footer"
'-------------------------------
SetVar "FileName", sFileName


'-------------------------------
' Step through each form
'-------------------------------
Menu_Show
FooterForm_Show
Response_Show
'-------------------------------
' Process page templates
'-------------------------------
Parse "Header", False
Parse "Footer", False
Parse "main", False
'-------------------------------
' Output the page to the browser
'-------------------------------
Response.write PrintVar("main")

' ResponseMaint Show end

'-------------------------------
' Destroy all object variables
'-------------------------------
cn.Close
Set cn = Nothing
UnloadTemplate
'===============================

'===============================
' ResponseMaint Close Event begin
' ResponseMaint Close Event end
'===============================
'===============================
' Action of the Record Form
'-------------------------------
Sub ResponseAction(sAction)
'-------------------------------
' Initialize variables  
'-------------------------------
  Dim bExecSQL: bExecSQL = true
  Dim sActionFileName : sActionFileName = ""
  Dim sParams : sParams = "?"
  Dim sWhere : sWhere = "" 
  Dim bErr : bErr = False
  Dim pPKresponse_id : pPKresponse_id = ""
  Dim flduser_id : flduser_id = ""
  Dim flddate_response : flddate_response = ""
  Dim fldresponse : fldresponse = ""
  Dim fldassigned_to : fldassigned_to = ""
  Dim fldpriority_id : fldpriority_id = ""
  Dim fldstatus_id : fldstatus_id = ""
'-------------------------------

'-------------------------------
' Response Action begin
'-------------------------------
  sActionFileName = "IssuesMaint.asp"
  sParams = sParams & "issue_id=" & ToURL(GetParam("Trn_issue_id"))

'-------------------------------
' CANCEL action
'-------------------------------
  if sAction = "cancel" then

'-------------------------------
' Response BeforeCancel Event begin
' Response BeforeCancel Event end
'-------------------------------
    cn.Close
    Set cn = Nothing
    response.redirect sActionFileName & sParams
  end if
'-------------------------------

'-------------------------------
' Build WHERE statement
'-------------------------------
  if sAction = "update" or sAction = "delete" then
    pPKresponse_id = GetParam("PK_response_id")
    if IsEmpty(pPKresponse_id) then exit sub
    sWhere = "response_id=" & ToSQL(pPKresponse_id, "Number")
  end if
'-------------------------------


'-------------------------------
' Load all form fields into variables
'-------------------------------
  flduser_id = GetParam("user_id")
  flddate_response = GetParam("date_response")
  fldresponse = GetParam("response")
  fldassigned_to = GetParam("assigned_to")
  fldpriority_id = GetParam("priority_id")
  fldstatus_id = GetParam("status_id")

'-------------------------------
' Create SQL statement
'-------------------------------
  select case sAction
    case "update"
'-------------------------------
' Response Update Event begin
' Response Update Event end
'-------------------------------
      sSQL = "update responses set " & _
        "[user_id]=" & ToSQL(flduser_id, "Number") & _
        ",[date_response]=" & ToSQL(flddate_response, "Date") & _
        ",[response]=" & ToSQL(fldresponse, "Text") & _
        ",[assigned_to]=" & ToSQL(fldassigned_to, "Number") & _
        ",[priority_id]=" & ToSQL(fldpriority_id, "Number") & _
        ",[status_id]=" & ToSQL(fldstatus_id, "Number")
      sSQL = sSQL & " where " & sWhere
    case "delete"
'-------------------------------
' Response Delete Event begin
' Response Delete Event end
'-------------------------------
      sSQL = "delete from responses where " & sWhere
  end select
'-------------------------------
'-------------------------------
' Response BeforeExecute Event begin
' Response BeforeExecute Event end
'-------------------------------

'-------------------------------
' Execute SQL statement
'-------------------------------
if len(sResponseErr) > 0 then Exit Sub
  on error resume next
  if bExecSQL then 
    cn.execute sSQL
  end if
  sResponseErr = ProcessError
  on error goto 0
  if len(sResponseErr) > 0 then Exit Sub
  cn.Close
  Set cn = Nothing
  response.redirect sActionFileName & sParams
'-------------------------------
' Response Action end
'-------------------------------
end sub
'===============================

'===============================
' Display Record Form
'-------------------------------
Sub Response_Show()
'-------------------------------
' Response Show begin
'-------------------------------
  Dim sWhere : sWhere = ""
  Dim sFormTitle: sFormTitle = "Edit Response"
  Dim bPK : bPK = True

'-------------------------------
' Load primary key and form parameters
'-------------------------------
  if sResponseErr = "" then
    fldissue_id = GetParam("issue_id")
    SetVar "Trn_issue_id", GetParam("issue_id")
    presponse_id = GetParam("response_id")
    SetVar "ResponseError", ""
  else
    fldresponse_id = GetParam("response_id")
    flduser_id = GetParam("user_id")
    flddate_response = GetParam("date_response")
    fldresponse = GetParam("response")
    fldassigned_to = GetParam("assigned_to")
    fldpriority_id = GetParam("priority_id")
    fldstatus_id = GetParam("status_id")
    SetVar "Trn_issue_id", GetParam("Trn_issue_id")
    presponse_id = GetParam("PK_response_id")
    SetVar "sResponseErr", sResponseErr
    SetVar "FormTitle", sFormTitle
    Parse "ResponseError", False
  end if
'-------------------------------

'-------------------------------
' Load all form fields

'-------------------------------

'-------------------------------
' Build WHERE statement

  if IsEmpty(presponse_id) then bPK = False
  
  sWhere = sWhere & "response_id=" & ToSQL(presponse_id, "Number")
  SetVar "PK_response_id", presponse_id
'-------------------------------
'-------------------------------
' Response Open Event begin
' Response Open Event end
'-------------------------------

  SetVar "FormTitle", sFormTitle

'-------------------------------
' Build SQL statement and open recordset
'-------------------------------
  sSQL = "select * from responses where " & sWhere
  openrs rs, sSQL
  bIsUpdateMode = (bPK and not(sAction = "insert" and sForm = "Response") and not rs.eof)
'-------------------------------

'-------------------------------
' Load all fields into variables from recordset or input parameters
'-------------------------------
  if bIsUpdateMode then
    fldresponse_id = GetValue(rs, "response_id")

'-------------------------------
' Load data from recordset when form displayed first time
'-------------------------------
    if sResponseErr = "" then
      flduser_id = GetValue(rs, "user_id")
      flddate_response = GetValue(rs, "date_response")
      fldresponse = GetValue(rs, "response")
      fldassigned_to = GetValue(rs, "assigned_to")
      fldpriority_id = GetValue(rs, "priority_id")
      fldstatus_id = GetValue(rs, "status_id")
    end if
    SetVar "ResponseInsert", ""
    Parse "ResponseEdit", False
'-------------------------------
' Response ShowEdit Event begin
' Response ShowEdit Event end
'-------------------------------
  else
    SetVar "ResponseEdit", ""
    SetVar "ResponseInsert", ""
'-------------------------------
' Response ShowInsert Event begin
' Response ShowInsert Event end
'-------------------------------
  end if
  Parse "ResponseCancel", false
'-------------------------------
' Response Show Event begin
' Response Show Event end
'-------------------------------

'-------------------------------
' Show form field
'-------------------------------
      SetVar "response_id", ToHTML(fldresponse_id)
      SetVar "ResponseLBuser_id", ""
      openrs rsuser_id, "select user_id, user_name from users order by 2"
      while not rsuser_id.EOF
        SetVar "ID", GetValue(rsuser_id, 0) : SetVar "Value", GetValue(rsuser_id, 1)
        if cstr(GetValue(rsuser_id, 0)) = cstr(flduser_id) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "ResponseLBuser_id", True
        rsuser_id.MoveNext
      wend
      set rsuser_id = nothing
    
      SetVar "date_response", ToHTML(flddate_response)
      SetVar "response", ToHTML(fldresponse)
      SetVar "ResponseLBassigned_to", ""
      openrs rsassigned_to, "select user_id, user_name from users order by 2"
      while not rsassigned_to.EOF
        SetVar "ID", GetValue(rsassigned_to, 0) : SetVar "Value", GetValue(rsassigned_to, 1)
        if cstr(GetValue(rsassigned_to, 0)) = cstr(fldassigned_to) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "ResponseLBassigned_to", True
        rsassigned_to.MoveNext
      wend
      set rsassigned_to = nothing
    
      SetVar "ResponseLBpriority_id", ""
      openrs rspriority_id, "select priority_id, priority_desc from priorities order by 2"
      while not rspriority_id.EOF
        SetVar "ID", GetValue(rspriority_id, 0) : SetVar "Value", GetValue(rspriority_id, 1)
        if cstr(GetValue(rspriority_id, 0)) = cstr(fldpriority_id) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "ResponseLBpriority_id", True
        rspriority_id.MoveNext
      wend
      set rspriority_id = nothing
    
      SetVar "ResponseLBstatus_id", ""
      openrs rsstatus_id, "select status_id, status from statuses order by 2"
      while not rsstatus_id.EOF
        SetVar "ID", GetValue(rsstatus_id, 0) : SetVar "Value", GetValue(rsstatus_id, 1)
        if cstr(GetValue(rsstatus_id, 0)) = cstr(fldstatus_id) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "ResponseLBstatus_id", True
        rsstatus_id.MoveNext
      wend
      set rsstatus_id = nothing
    
  Parse "FormResponse", False

'-------------------------------
' Response Close Event begin
' Response Close Event end
'-------------------------------

Set rs = Nothing

'-------------------------------
' Response Show end
'-------------------------------
End Sub
'===============================
%>